# | User | Rating |
---|---|---|

1 | tourist | 3775 |

2 | Benq | 3724 |

3 | orzdevinwang | 3697 |

4 | Radewoosh | 3651 |

5 | jiangly | 3632 |

6 | cnnfls_csy | 3620 |

7 | -0.5 | 3545 |

8 | inaFSTream | 3478 |

9 | fantasy | 3468 |

10 | Rebelz | 3415 |

# | User | Contrib. |
---|---|---|

1 | adamant | 178 |

2 | awoo | 167 |

3 | BledDest | 165 |

4 | Um_nik | 163 |

5 | maroonrk | 162 |

6 | SecondThread | 160 |

7 | nor | 158 |

8 | -is-this-fft- | 154 |

9 | kostka | 146 |

10 | TheScrasse | 144 |

Codeforces (c) Copyright 2010-2023 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Oct/01/2023 09:25:49 (h1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|

Can anyone give a mathematical proof for Div 2 B, second point? It seems correct intuitively, and not able to come up with counter cases. How does everyone discover this fact?

At each turn, take the maximum element and the minimum element, and reduce each by 1. At this point the second point still holds true.

Consider the case when the maximum element got reduced by 1, and it became not the maximum. Then the sorted array looks like this:

$$$....., x, x - 1.$$$

Since the total sum is still even, there is another positive element ($$$\ge 1$$$), apart from these two. Then $$$x \le (x - 1) +$$$ "some elements, at least one of which is 1". So the second point still holds, and we continue with x as the maximum element.

I'll have a crack at a possible explanation.

The problem statement instructs us to pick 2 distinct indices and reduce each element by 1. Suppose the point in consideration "The biggest element has to be less or equal than the sum of all the other elements." were to be false. Let this biggest element be at index i. For all other indices j, if we pick (i, j) as our pair and reduce their values by 1, we should be able to see that it won't be possible to reduce the largest element to 0.

Proof by contradiction. Nice.

This definately proves that if the largest element is greater than the sum of all other elements — Then all elements can never be made 0. Cool...!

But if largest element is less than sum of all other elements ; how can you guarantee that it is always possible to make all elements = 0...? Could you explain this please...

This is a great explanation.

Thanks

How this test case correct answer is YES, for problem 2? Can anyone explain that?

5

1000000000 1000000000 1000000000 1000000000 1000000000

got it

Can you please explain this testcase I am still not able to understand.

In this test case we are pairing one of the element with the others one by one.

1000000000 1000000000 1000000000 1000000000 1000000000

will turn to

750000000 750000000 750000000 750000000 0

we have deducted 250000000 from the 4 1000000000s and reduced the 5th one to 0.

Thanks Brother, it really helped :)

This is like 2 2 2 2 2 We make the following changes

1 1 2 2 2

1 1 1 1 2

0 0 1 0 1

0 0 0 0 0

Here is another way to think about it.

Consider 2 cases:

Let's say that each element of the array represents the number of marbles of a given color. We can take 2 bowls. On the 1st, we put all the marbles of the largest number, while on the 2nd we put all the remaining ones. On each operation, we can take one marble from both of them. As they contain the same number of marbles, they will become empty at the same time and we are finished!

We will try to reduce this to the above case! Again, we fill the bowls with the same way. The difference is that now the 2nd bowl has more marbles. To solve this, we can begin picking pairs from it until they are equal! Note that, as the sum is an even number, the parity of the number of marbles on each bowl is the same (ie. both odd or both even). That guarantees us that we will 100% reach a point that they are equal!

But why can't we get stuck while picking pairs from second bowl in the second case? This needs a bit of explanation.

I see it differently. If one element is exactly half of all, we can easily pair it with others. But if all are less than this half, then we can pick any pair (it exists, since there are at least 2 colors, since if there were just 1 color, it would have all marbles and that is not less than half). Picking any pair reduces total count by 2 (or half by 1). As soon as this "half" gets equal to any of the values, we switch to case 1. Since it gets decremented by 1, it will be equal to some of the lower values without skipping it, sooner or later.

First you must realize that finally, in last step of reduction, the array will be of form: 1 1 0 0 0 0...... So if we backtrack from here to generate all possible arrays, at each step you increment the whole sum of array by 2, but for any element, you can only increase it by 1 in that step.So even if a single element is focused on every time, max(arr[i])<=sum/2. Hope it helps!

One of the best explanations! However, this does prove that these are the necessary conditions, but how do we know these are the only sufficient conditions?

After this constraint is applied, the question simply reduces to : Design array with given even sum and maximum element less than equal to sum/2, by incrementing any number, which is trivial to see I think.

One more proof:

Let's make an optimal selection of pairs — we would have

`P`

pairs and`U`

unassigned.1). If

`U`

is empty — we can zero array2). If

`U`

is odd — sum of an array was odd and the answer is`NO`

3.1). If

`U`

is even and has more than 2 elements — all`U`

must be coming from a single`A[i]`

because our selection is optimal.3.2). If there is a pair in P

`(a, b)`

and both`a`

and`b`

are not from`i`

— we can reassign 2 elements from`U`

and`a`

,`b`

and make`U`

lower. Which is impossible because our selection is optimal. Thus, all pairs in`P`

has one element from`A[i]`

and other element from somewhere else. So it means,`A[i] = U + P`

, and`sum(A) - A[i] = P`

.`A[i]`

must be biggest element and it is bigger than half of`sum(A)`

Explaining the case where the maximum element is less than the sum of the remaining elements:

Let's call the maximum element

`X`

, the sum of the remaining elements`remSum`

and`X+remSum`

is the total sum.Since

`X+remSum`

must beeven, then`X`

and`remSum`

mustbothbeevenorodd, then for`remSum`

to be greater than`X`

it has to be greater by anevenamount`remSum = X+2*k`

, otherwise the total sum won't be even.Consider the case where

`X = 5`

and`remSum = 7`

Notice:`remSum`

is greater than`X`

by 2 (anevenamount)`1, 1, 2, 3, 5`

where`X = 5`

and`remSum = 1 + 1 + 2 + 3`

decrease

`remSum`

by 2 using any pair of elements from`remSum`

, e.g. the pair at indices 0 , 3the resulting elements are

`0, 1, 2, 2, 5`

Now

`X = 5`

and`remSum = 5`

, subtracting`X`

from all elements of`remSum`

will then result in an array of all 0's.Using this fact, we are sure that for any case where

`remSum > X`

and`remSum+X`

is an even number, we can always remove the extraevenamount`2*k`

from`remSum`

and reach a feasible state where the sum of the remaining elements is equal to the maximum element.Really good explanation. Thanks!

Hey. Can u pls show its working on 1,3,4,4

Really great explanation....

Tell me how do you guys think in such ways...I mean how its easy to prove the conjecture but tell me how do you approach the problem...

Thanks for this great explanation!

he made the question and god knows the proof ..

I am 18 months late, if anyone still has a doubt...here you go

Let the elements of the array be

[a,b,c,d]where d is the largest elementLet us assume d is

smaller than or equal to a+b+c(sum of all other elements)d = a+b+c — deltawe know that d+a+b+c is even, 2(a+b+c) — delta is even and hence

delta must be even.Now, we

can keep picking any 2 elementsfrom [a,b,c] andreduce them delta/2times so that d becomes equal to a+b+c...Here's my take on explaining the 2nd point of the solution:

we dont have an index i=S/2.In other words Sn-1<S/2 which implies that the max element i.ea[n]>S/2which is what the 2nd point is trying to state.Can someone help me? I cant find what's wrong with my code. https://mirror.codeforces.com/contest/1201/submission/58307080

I am not sure, but try to swap rows "cin.tie(0)" and "iostream..."

It doesn't work. :(

He shouldn't swap them.

`ios_base::sync_with_stdio(false)`

or equivalent resets`cin.tie`

s state. So you should always have them in that order.in using colum[where[j]+k], where[j]+k is an invalid index. it is accessing an index beyond size of the vector.

I fixed it but it still doesn't work. I don't know why. And it doesn't work in test case 1 in CF but in works when I try it in Xcode... https://mirror.codeforces.com/contest/1201/submission/58320302

ll where[m] is not initialized properly. You forgot to assign values from 0 to colum[0]. So it causes an index overflow when you try to refer to colum[where[j] + k]

yeah, you are right! thank you!

Bonus: solve problem C with linear time complexity.Was binary search actually necessary? I thought that simply sorting and maintaining how many elements would require updating to increase the median for each i between n / 2 and n would suffice.

For instance, if the initial median were some 'x' and the successor of 'x' were to be 'y' in the given array, it would require 'y' — 'x' updates to make 'x' = 'y'. Now, as any further increments to 'x' would yield 'y' as the median, it mandates updating both terms (equal to 'y') to their succeeding value. This can be maintained using a 'termsToUpdate' counter.

Sorting is not linear.

Oops, my bad. Though, I guess a similar technique could be used with quickselect. Not too sure about it.

I guess no because we not only want median but also number greater than median in a sorted order so I think sorting has to be done.

Note that the array has to be sorted.

Sorry, I didn’t notice that the array in this problem is not sorted. It was hard to notice it for me because I have the same problem with sorted array in Polygon. Of course I meant linear solution with sorted array. Sorry for misunderstanding.

Well I guess sorting of integers $$$<=10^9$$$ with $$$N$$$ equal to $$$1e5$$$ might be considered as linear [almost].. just 2 counting sorts

58273442 Is that what you meant?

Yes, something like that.

Well, if we ignore the complexity of sorting the array then we can just iterate from i=n/2 to i = n-1 and keep making all elements between n/2 to i. equal to A[i]. We break the loop if k goes negative. Here is code. https://mirror.codeforces.com/contest/1201/submission/58290181

Igoring sorting, my solution is pretty fast.58914655

Proof for B:

Claim 1: the initial sum must be even

The operation does not change the parity of the sum. Since the sum of an array of zeros is even, the initial sum must also be even.

Claim 2: assuming the initial sum is even, then it is necessary and sufficient that there is no element in the initial array that is larger than half of the initial sum

To prove necessity, consider an initial array with an element that is larger than half of the initial sum. Thus, this element is also larger than the sum of the other elements. Separate this from the other elements. Notice that, each operation either subtracts 1 from the element and subtracts 1 from the others, or subtracts 2 from the others. Thus, we can only subtract as much from the element as the sum of the others. Since the element is larger than the sum of the others, it will not reach zero.

To prove sufficiency, we notice the following properties of an array of zeros: its total sum is zero and its largest element is not larger than its total sum. Since each operation decreases the total sum, we will eventually reach zero. Call an array good if it has no element larger than half of its total sum. Thus, we only have to prove that we can always perform an operation on a good array with nonzero sum such that the result array is also good. Consider a good array with nonzero sum. We claim that subtracting 1 from the two largest elements will result in a good array. Note that there is at least one nonzero element since the sum is nonzero. And there are at least two since the array is good. Thus, it is always possible to subtract from two elements. If subtracting from the two largest elements doesn't result in a good array, then there is an element distinct from the two largest elements that is larger than $$$\frac{s - 2}{2}$$$, where $$$s$$$ is the sum of the array before subtracting from the two largest elements. Since the two largest elements are at least as large as this element, the total sum before subtraction is at least $$$3 \cdot \frac{s}{2}$$$ but at most $$$s$$$. However, this leads to the inequality $$$s \leq 0$$$. Since the sum can never be less than zero, $$$s = 0$$$. However, we assumed that the sum is nonzero. This is clearly a contradiction. Thus, subtracting from the two largest elements of a good array will always result in a good array.

can someone please explain D solution in english

Every time you reach a row that has treasure, you have to get all treasure before you go to the next row, so you will finally stop at the leftmost or the rightmost treasure. It's the same for the next now that has treasure. So you can just calculate the cost of 4 paths: L1->L2 / L1->R2 / R1->L2 / R1->R2 , and save the minimum of L2 and R2 for the next row, continue to do the same thing.

A minor issue for time complexity in problem C. The sorting is already

`O(nlogn)`

. Or is it supposed to ignore such trivial operations in complexity analysis? Besides, a linear implementation to solve the problem after sorting is here.O(nlogn) + O(nlogn) = O(nlogn)

Can someone please explain C in detail, I am not able to understand it.

How it's 4 possibly for every row in problem D? 1- we can go to rightmost and then left most and then to the closet safe column to the leftmost one treasure. 2- we can go left and then right and then to the closet safe column. (reverse order of 1)

what possibilities im not considering?

Closest safe columns right to the leftest treasure, left to the leftest treasure and same for rightest treasure.

So cant we get the minimum of the right and left safe column?

2 23 3 3

1 19

2 22

2 1

1 16 23

correct answer:

45

So how we can see which one is better? Do we need to check that if we go left then at the next we have to go there? And if its then it will effect on other rows chooses ? So we need dp?

of course we need dp, we must know answer for leftmost-left, leftmost-right, rightmost-left and rightmost-right. after we use that 4 numbers to calculate same thing for next line

Thank you very much :(

Why is the right answer $$$45$$$ and not $$$44$$$? One possible path of weight $$$44$$$ is $$$(1,1)\ ->\ (1,19)\ ->\ (1,23)\ ->\ (2,23)\ ->\ (2,22)\ ->\ (2,2)$$$.

sorry, I thought that third treasure was at 2 1

In problem D if we assume that each row has atlest one treasure then does this greedy computes optimal answer?

Move in zig-zag fashion i.e. In first row collect treasures in order from left to right. In second row from right to left, in third from left to right and so on.

Why there must be a treasure to the left of it?

That doesn't ensure minimum number of moves.

.

1 2 3 6 8 -> 1 2 3 0 2 -> 1 1 2 0 2 -> 0 0 0 0 0 // done

I have solved in this way. (div2/c) can anyone tell in what catergory my solution goes? (Binary Search, greedy, math)? submission: link

What do you think? Looks greedy to me

Could someone tell me what's wrong with my solution for D https://mirror.codeforces.com/contest/1201/submission/58341150

can someone explain problem C editorial better please?

Yeah, specifically the method of applying

binary searchin this condition.How do you realise that binary search must be done?I'm curious if anyone has Greedy solution for Treasure Hunting (D) (Greedy tag)

I think we can simply use dijkstra algorithm as this is akin to minimum cost to reach destination from source problem, where there are 4 nodes in every row

58326485

Isn't time complexity of editorial's solution for problem C nlogn+log(1e9)? Someone please fix me if I'm wrong about that.

My solution for problem C. Complexity: nlogn + n/2 58305249

Hey, I came up with an O(nlogn) + linear time complexity for Div2 C, kindly correct me if I am wrong or a similar solution has been posted!

answer is (max + ((k-change)/len)) https://mirror.codeforces.com/contest/1201/submission/58301289

Can anyone explain me how the answer for the "B. Zero Arrays " for the 5th test case " 5 1000000000 1000000000 1000000000 1000000000 1000000000 " The answer is "YES" How ??

consider 5 2 2 2 2 2

DIV2 D is very similar to this 1066F - Очередная ходьба в 2D